문제
Given an integer array nums sorted in non-decreasing order, remove some duplicates in-place such that each unique element appears at most twice. The relative order of the elements should be kept the same.
Since it is impossible to change the length of the array in some languages, you must instead have the result be placed in the first part of the array nums. More formally, if there are k elements after removing the duplicates, then the first k elements of nums should hold the final result. It does not matter what you leave beyond the first k elements.
Return k after placing the final result in the first k slots of nums.
Do not allocate extra space for another array. You must do this by modifying the input array in-place with O(1) extra memory.
Custom Judge:
The judge will test your solution with the following code:
int[] nums = [...]; // Input array
int[] expectedNums = [...]; // The expected answer with correct length
int k = removeDuplicates(nums); // Calls your implementation
assert k == expectedNums.length;
for (int i = 0; i < k; i++) {
assert nums[i] == expectedNums[i];
}
If all assertions pass, then your solution will be accepted.
Example 1:
Input: nums = [1,1,1,2,2,3]
Output: 5, nums = [1,1,2,2,3,_]
Explanation: Your function should return k = 5, with the first five elements of nums being 1, 1, 2, 2 and 3 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).
Example 2:
Input: nums = [0,0,1,1,1,1,2,3,3]
Output: 7, nums = [0,0,1,1,2,3,3,_,_]
Explanation: Your function should return k = 7, with the first seven elements of nums being 0, 0, 1, 1, 2, 3 and 3 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).
Constraints:
- 1 <= nums.length <= 3 * 104
- -104 <= nums[i] <= 104
- nums is sorted in non-decreasing order.
오름차순으로 정렬된 배열 nums
에서 각 원소가 최대 2번 나타나도록 일부 중복을 제거하는 문제이다.
중복을 제거한 후 남은 원소의 개수 k
를 반환한다.
다른 추가 공간을 할당하지 말고 O(1) 을 유지하면 직접 입력 배열을 수정해야한다.
내 풀이
첫 번째 풀이
공간복잡도가 O(1)이어야한다는 조건이 있어서 꽤 오래 고민했지만 해결하지 못했다.
결국 HashMap을 사용해서 일단 풀었다.
class Solution {
public int removeDuplicates(int[] nums) {
Map<Integer, Integer> map = new HashMap<>();
int k = 0;
for(int i=0; i<nums.length; i++){
int count = map.getOrDefault(nums[i], 0);
if(count < 2){
nums[k] = nums[i];
k++;
}
map.put(nums[i], count +1);
}
return k;
}
}
- 시간복잡도 : O(n)
- 공간복잡도 : O(n)
두 번째 풀이
머리를 한번 식히고 추가메모리를 사용하지 않고 해결하는 방법에 다시 도전해보았다.
class Solution {
public int removeDuplicates(int[] nums) {
if(nums.length < 2){
return nums.length;
}
int k = 1;
int count = 1;
for (int i = 1; i < nums.length; i++) {
if (nums[i] == nums[i - 1]) {
count++;
} else {
count = 1;
}
if (count <= 2) {
nums[k] = nums[i];
k++;
}
}
return k;
}
}
일단 길이가 2이하인 배열들은 그대로 리턴해준다.
직전의 원소랑 비교해서 같으면 count
를 +1 해주고, 같지 않으면 1로 초기화한다.
또한 count
가 2 이하일 때만 배열의 처음부터 값을 채워주었다.
엄청 삽질하다가 인텔리제이에서 디버깅을 거쳐 코드를 완성해서 뭔가 내가 진짜 풀었다는 느낌이 들지 않았다는 점ㅠㅠ
다른 사람의 풀이
class Solution {
public int removeDuplicates(int[] nums) {
int k = 2;
for(int i=2; i<nums.length; i++){
if(nums[i] != nums[k-2]){
nums[k] = nums[i];
k++;
}
}
return k;
}
}
훨씬 간단하다….❗
if문도 한번만 쓰면서 변수도 k
하나만 사용하는 거의 정답에 가까운 코드인 것 같다.
왜 이런 생각을 못했을까라고 다시 한 번 반성하는 시간을 가졌다..
열심히 해야지
'알고리즘 > 자료구조' 카테고리의 다른 글
[LeetCode] 121. Best Time to Buy and Sell Stock - Java (0) | 2023.08.24 |
---|---|
[LeetCode] 169. Majority Element - Java (0) | 2023.08.24 |
[LeetCode] 26. Remove Duplicates from Sorted Array - Java (0) | 2023.08.24 |
[LeetCode] 27. Remove Element - Java (0) | 2023.08.24 |
[LeetCode] 88. Merge Sorted Array - Java (0) | 2023.08.24 |